$(document).ready(function() {

  $("input[type='email']").keydown(function() {
    $("input[type='email']").removeClass("error-input");
  });

  //Selecciona tipo de calendario de acuerdo al dispositivo
  datepicker_chose();

  //CREW - Sólo permite del 1 al 9
  $('.numeric_one').mask('0', {
    translation: {
      '0': {
        pattern: /[1-9]/
      }
    }
  });

  //PAX sólo 3 números
  $('.numeric_two').mask('99');

  //Checa tipo de dispositivo para adaptar inputs de números
  inputs_mobile();

  //En Request Quote sólo permite un checkbox seleccionado
  $('#selection_service input[type="checkbox"]').on('change', function() {
    $('#selection_service input[type="checkbox"]').not(this).prop('checked', false);
  });
});

//Checa tipo de dispositivo para adaptar inputs de números
function inputs_mobile() {
  if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
    $('.numeric_one').attr('type', 'number');
    $('.passenger_special').attr('type', 'number');
    $('.numeric_two').attr('type', 'number');
  } else {
    $('.numeric_one').attr('type', 'text');
    $('.passenger_special').attr('type', 'text');
    $('.numeric_two').attr('type', 'text');
  }
}

//Para añadir vuelos
var leg = 3;

function new_flight() {
  $('#legs').append('<div class="row bonus disappear"><div class="large-12 columns title_4"><h2>Leg ' + leg + '</h2><div></div></div></div><div class="form_collapse row bonus disappear"><div class="large-12 columns"><div class="large-3 columns"><label>Dep. Apt.</label><input type="text" placeholder="ICAO" class="depApt" maxlength="4" required name="dep_apt[]"/></div><div class="large-4 columns"><label>Arr. Apt.</label><input type="text" placeholder="ICAO" class="arrApt" maxlength="4" required name="arr_apt[]"/></div><div class="large-3 columns"><label>Date</label><input type="text" value="" class="text-center datepicker" placeholder="dd/mmm/yyyy" required readonly name="date[]"><div class="containerDate"></div></div><div class="large-1 columns"><label>#Crew</label><input class="numeric_one text-center" oninput="javascript: if (this.value.length > this.maxLength) this.value = this.value.slice(0, this.maxLength);" maxlength="1" placeholder="0" required name="crew[]"/></div><div class="large-1 columns"><label>#Pax</label><input class="numeric_two text-center" oninput="javascript: if (this.value.length > this.maxLength) this.value = this.value.slice(0, this.maxLength);" maxlength="2" placeholder="0" required name="pax[]"/></div></div></div>');
  titles();
  inputs_mobile();
  datepicker_chose();
  leg = leg + 1;
  if (leg == 11) {
    $('.add_flight').hide();
  }
}

//Para añadir vuelos en REQUEST QUOTE
var leg_rq = 4;

function new_flight_rq() {
  $('#legs').append('<div class="row bonus disappear"><div class="large-12 columns title_4"><h2>Leg ' + leg_rq + '</h2><div></div></div></div><div class="form_collapse row bonus disappear"><div class="large-12 columns"><div class="large-3 columns"><label>Dep. Apt.</label><input type="text" placeholder="ICAO" class="depApt" maxlength="4" required name="dep_apt[]"/></div><div class="large-4 columns"><label>Arr. Apt.</label><input type="text" placeholder="ICAO" class="arrApt" maxlength="4" required name="arr_apt[]"/></div><div class="large-3 columns"><label>Date</label><input type="text" value="" class="text-center datepicker" placeholder="dd/mmm/yyyy" required readonly name="date[]"><div class="containerDate"></div></div><div class="large-1 columns"><label>#Crew</label><input class="numeric_one text-center" oninput="javascript: if (this.value.length > this.maxLength) this.value = this.value.slice(0, this.maxLength);" maxlength="1" placeholder="0" required name="crew[]"/></div><div class="large-1 columns"><label>#Pax</label><input class="numeric_two text-center" oninput="javascript: if (this.value.length > this.maxLength) this.value = this.value.slice(0, this.maxLength);" maxlength="2" placeholder="0" required name="pax[]"/></div></div></div>');
  titles();
  inputs_mobile();
  datepicker_chose();
  leg_rq = leg_rq + 1;
  if (leg_rq == 11) {
    $('.add_flight').hide();
  }
}

//Para mostrar y ocultar la ayuda
function showWindow() {
  $('#window_help').show();
  if ($(window).width() < 1025) {
    $('body').css('overflow', 'hidden');
  }
}

// VALIDACIONES
//Variables
var form = false;
var thank_you_form = false;
var leg_chk;
var rq = false;

//Validaciones para completar legs que se empiezan a llenar
//pero no se completa la información
function validation(leg_chk) {
  var extra = 0;
  $('form.rectangle_form').find('.form_collapse.row.bonus').each(function() {
    $(this).find('input').each(function() {
      if ($(this).val().length > 0) {
        extra = extra + 1;
      }
    });
    leg_chk = leg_chk + 1;
    document.getElementById('leg_number').innerHTML = leg_chk;
    if (extra == 0) {
      extra = 0;
      form = true;
      return thank_you_form, form;
    } else if (extra == 5) {
      extra = 0;
      form = true;
      thank_you_form = true;
      return thank_you_form, form;
    } else if (extra == 4) {
      var pax = $(this).find("input.numeric_two").val();
      if (pax == '') {
        extra = 0;
        form = true;
        thank_you_form = true;
        return thank_you_form, form;
      } else {
        if (leg_chk == 2) {
          document.getElementById('leg_si').innerHTML = 'nd';
        } else if (leg_chk == 3) {
          document.getElementById('leg_si').innerHTML = 'rd';
        } else {
          document.getElementById('leg_si').innerHTML = 'th';
        }
        $('#complete_required').show();
        form = false;
        extra = 0;
        return false;
      }
    } else {
      if (leg_chk == 2) {
        document.getElementById('leg_si').innerHTML = 'nd';
      } else if (leg_chk == 3) {
        document.getElementById('leg_si').innerHTML = 'rd';
      } else {
        document.getElementById('leg_si').innerHTML = 'th';
      }
      $('#complete_required').show();
      form = false;
      extra = 0;
      return false;
    }
  });
}

function validEmail(emailAddress) {
  var emailRegex = /^([\w\.\-]+)@([\w\-]+)((\.(\w){2,3})+)$/i;
  var valid = emailRegex.test(emailAddress);
  if (!valid) {
    return false;
  } else
    return true;
}

//Mensajes de required - Ground Handling
function valider_GH(rq) {
  $('.windowRequired').hide();
  $('.windowHelp').hide();
  $('form.rectangle_form').find('input').each(function() {
    if (!$(this).val().length > 0) {
      if ($(window).width() < 1025) {
        $('body').css('overflow', 'hidden');
      }
      if ($(this).hasClass('basic_information')) {
        $('#trip_information_required').show();
        form = false;
        return false;
      } else if ($(this).hasClass('leg')) {
        $('#leg_required_gh').show();
        form = false;
        return false;
      }
    } else if ($(this).attr('type') == 'email') {
      var emailAddress = $(this).val();
      if (!validEmail(emailAddress)) {
        if (/webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
          $('html, body').animate({
            scrollTop: parseInt($(this).offset().top) - 40
          }, 500);
        }
        $(this).focus();
        $(this).addClass("error-input");
        form = false;
        return false;
      } else {
        $(this).removeClass("error-input");
      }
    } else {
      form = true;
    }
  });

  if (form == true) {
    if (rq == true) {
      leg_chk = 1;
    } else {
      leg_chk = 2;
    }
    validation(leg_chk);
  }

  if (form == true) {	  
	document.getElementById("form1").submit();	  	  
    /*$('#thank_you').show();
    //Borra el formulario
    $('form.rectangle_form')[0].reset();
    //Borra los vuelos que se hallan añadido
    $(".disappear").remove();
    //Resetear variables
    extra = 0;
    leg = 3;
    leg_rq = 4;
    form = false;
    return extra, leg, leg_rq, form;*/
  }
}

//Mensajes de required - General
function valider() {
  $('.windowRequired').hide();
  $('.windowHelp').hide();
  $('form.rectangle_form').find('input').each(function() {
    if (!$(this).val().length > 0) {
      if ($(window).width() < 1025) {
        $('body').css('overflow', 'hidden');
      }
      if ($(this).hasClass('basic_information')) {
        $('#trip_information_required').show();
        form = false;
        return false;
      } else if ($(this).hasClass('leg')) {
        if ($(this).parent().parent().parent().hasClass('bonus')) {
          form = true;
        } else {
          $('#leg_required').show();
          form = false;
          return false;
        }
      }
    } else if ($(this).attr('type') == 'email') {
      var emailAddress = $(this).val();
      if (!validEmail(emailAddress)) {
        if (/webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
          $('html, body').animate({
            scrollTop: parseInt($(this).offset().top) - 40
          }, 500);
        }
        $(this).focus();
        $(this).addClass("error-input");
        form = false;
        return false;
      } else {
        $(this).removeClass("error-input");
      }
    } else {
      form = true;
    }
  });

  if (form == true) {
    leg_chk = 1;
    validation(leg_chk);
  }

  if (form == true) {
    if (thank_you_form == true){
        accept_submit();
    }else{
      $('#important_notice').show();
    }
  }
}

//Submit del mensaje de los 3 servicios que no son Ground Handling
function accept_submit() {
	
  document.getElementById("form1").submit();	  			
  /*$('form.rectangle_form')[0].reset();
  $('#thank_you').show();
  $('#important_notice').hide();
  $(".disappear").remove();
  //Resetear variables
  extra = 0;
  leg = 3;
  leg_rq = 4;
  form = false;
  return extra, leg, leg_rq, form;*/
}

//Check required - Request Quote
function valider_RQ() {
  if ($('input#groundHandling_chk').is(':checked') || $('input#groundHandling_chk_m').is(':checked')) {
    rq = true;
    valider_GH(rq);
  } else if ($('input#aeronauticalPlanning_chk').is(':checked') || $('input#internationalPermits_chk').is(':checked') || $('input#airoverFees_chk').is(':checked') || $('input#aeronauticalPlanning_chk_m').is(':checked') || $('input#internationalPermits_chk_m').is(':checked') || $('input#airoverFees_chk_m').is(':checked')) {
    valider();
  } else {
    $('#service_requested_required').show();
  }
}

//Para ocultar ventanas
function hideWindow(window_popup) {
  var popup = '#' + window_popup.id;
  $(popup).hide();
  $('body').css('overflow', 'auto');
}

//Elige que calendario utilizar de acuerdo al dispositivo
function datepicker_chose() {
  if ($(window).width() < 1025) {
    $('.datepicker').pickadate({
      formatSubmit: undefined,
      container: '.containerDate',
      closeOnSelect: true,
      closeOnClear: true,
      format: 'dd/mmm/yyyy',
      min: true
    })
  } else {
    $(".datepicker")
      .datepicker({
        dateFormat: 'dd/M/yy',
        showButtonPanel: true,
        showOtherMonths: true,
        minDate: 0,
        closeText: 'Clear', // Text to show for "close" button
        onClose: function() {
          var event = arguments.callee.caller.caller.arguments[0];
          // If "Clear" gets clicked, then really clear it
          if ($(event.delegateTarget).hasClass('ui-datepicker-close')) {
            $(this).val('');
          }
        }
      })
  }
}
