<?php

//	Script Version 7.5.7

if(!defined("UBB_MAIN_PROGRAM")) exit;

function page_unstickpost_gpc () {
	return array(
		"input" => array(
			"Number" => array("Number","both","int"),
			"announce" => array("announce","both","int"),
		),
		"wordlets" => array("admin/unstickpost","admin/generic"),
		"user_fields" => "USER_TOPIC_VIEW_TYPE",
		"regonly" => 1,
		"admin_only" => 0,
		"admin_or_mod" => 1,
	);
} // end page_unstickpost_gpc

function page_unstickpost_run () {

	global $html,$user,$in,$ubbt_lang,$config,$myinfo,$forumvisit,$visit,$dbh,$userob;

	extract($in, EXTR_OVERWRITE | EXTR_REFS); // quick and dirty fix - extract hash values as vars
	
	$query = "
		select FORUM_ID,POST_ID
		from {$config['TABLE_PREFIX']}TOPICS
		where TOPIC_ID = ?
	";
	$sth = $dbh->do_placeholder_query($query,array($Number),__LINE__,__FILE__);
	list($Keyword,$first_post) = $dbh->fetch_array($sth);

	if (!$userob->check_access("forum","STICKY_ANY",$Keyword)) exit;
	
	// ------------------
	// Get the forum info
	$query = "
	SELECT FORUM_CUSTOM_HEADER,FORUM_STYLE,FORUM_TITLE,CATEGORY_ID,FORUM_PARENT
	FROM   {$config['TABLE_PREFIX']}FORUMS
	WHERE  FORUM_ID = ?
	";
	$sth = $dbh -> do_placeholder_query($query,array($Keyword),__LINE__,__FILE__);
	list ($fheader,$fstyle,$Title,$cat_id,$parent_id) = $dbh -> fetch_array($sth);

	// fstyle will now be a global variable to use in send_header
	if ($fstyle) {
		$html->set_style($fstyle);
	} // end if


	// -----------------------------------------------------------------------
	// Mark the POST_POSTED_TIME and POST_TOPIC_LAST_POST_TIME as sticky and update the sticky field
	$query = "
	UPDATE {$config['TABLE_PREFIX']}TOPICS
	SET    TOPIC_IS_STICKY    = '0'
	WHERE  TOPIC_ID = ?
	";
	$dbh -> do_placeholder_query($query,array($Number),__LINE__,__FILE__);

	$body = "BODY";
	$sboard = $Keyword;

	if ($announce) {
		$body = "ANNOUNCEBODY";
		$sboard = "ubbt_all_forums";
	}

	// Remove from the announcements table
	$query = "
	DELETE FROM {$config['TABLE_PREFIX']}ANNOUNCEMENTS
	WHERE TOPIC_ID = ?
	AND FORUM_ID = ?
	";
	$dbh -> do_placeholder_query($query,array($Number,$sboard),__LINE__,__FILE__);
	
	// ------------------------
	// Send them a page
	$cfrm = make_ubb_url("ubb=cfrm");
	$html->send_redirect(
		array(
			"redirect" => "show{$user['USER_TOPIC_VIEW_TYPE']}&Number=$first_post",
			"heading" => $ubbt_lang['HEAD'],
			"body" => $ubbt_lang[$body],
			"returnlink" => "",
			"Board" => $Keyword,
			"Category" => $cat_id,
			"forum_parent" => $parent_id,
			"custom_header_footer" => $fheader,
			"breadcrumb" => <<<BREADCRUMB
 <a href="{$cfrm}">{$ubbt_lang['FORUM_TEXT']}</a>
BREADCRUMB
			,
		)
	);

}

?>
