var wb = new Workbook();
var ws = {};

//merge cells:
ws['!merges'] = [ 
    XLSX.utils.decode_range("A1:L1"),
    XLSX.utils.decode_range("A3:C3"),
    XLSX.utils.decode_range("A4:C4"),    
    XLSX.utils.decode_range("A6:C6"),
    XLSX.utils.decode_range("A7:C7"),
    XLSX.utils.decode_range("A8:C8"),
    XLSX.utils.decode_range("A9:C9"),
    XLSX.utils.decode_range("A10:C10"),
    XLSX.utils.decode_range("D7:E7"),
    XLSX.utils.decode_range("D8:E8"),
    XLSX.utils.decode_range("D10:E10"),
    XLSX.utils.decode_range("D9:E9"),    
    XLSX.utils.decode_range("B12:B13"),
    XLSX.utils.decode_range("C12:C13"),
    XLSX.utils.decode_range("D12:D13"),
    XLSX.utils.decode_range("E12:E13"),
    XLSX.utils.decode_range("F12:F13"),
    XLSX.utils.decode_range("G12:G13"),
    XLSX.utils.decode_range("H12:H13"),
    XLSX.utils.decode_range("I11:I13"),
    XLSX.utils.decode_range("J11:J13"),
    XLSX.utils.decode_range("K11:K13"),
    XLSX.utils.decode_range("A25:C25"),
    XLSX.utils.decode_range("D25:K25")    
];

wb.Props = {
	Title: "Quote Request",
	Subject: "Handling",
	Author: "I.T. Caribbean Sky Tours",	
	Company: "Caribbean Sky Tours"
};

/*****************QMS Styles**********************************/
var header = {
    font: {
        name: "Calibri",
        sz: 12,
        bold: true,
        underline: false,
        color: {rgb: "FFFFFF"}
    },
    fill: { fgColor: { rgb: "4473C5"}},
    border: {        
        bottom: {style: 'thin', color: {rgb: "00000000"}},
        right: {style: 'medium', color: {rgb: "00000000"}}
    },
    alignment: {
        vertical: "center",
        horizontal: "center",                
    }
};
var customerInformation = {
    font: {
        name: "Times New Roman",
        sz: 10,
        bold: true,
        underline: false,
        color: {rgb: "000000"}
    },    
    fill: { fgColor: { rgb: "FFFFFF"}},
    alignment: {
        vertical: "center",
        horizontal: "right",                
    }
};
var customerInformationText = {
    font: {
        name: "Arial",
        sz: 11,
        bold: false,
        underline: false,
        color: {rgb: "000000"}
    },    
    border: {
        top: {style: 'medium', color: {rgb: "000000"}},
        left: {style: 'medium', color: {rgb: "000000"}},
        right: {style: 'medium', color: {rgb: "000000"}},
        bottom: {style: 'medium', color: {rgb: "000000"}}
    }
};
var tripHeader = {
    font: {
        name: "Times New Roman",
        sz: 11,
        bold: true,
        underline: false,
        color: {rgb: "000000"}
    },    
    fill: { fgColor: { rgb: "FFFFFF"}},   
    alignment: {
        vertical: "center",
        horizontal: "center",
        wrapText: true
    }
};
var tripHeader60Degrees = {
    font: {
        name: "Times New Roman",
        sz: 9,
        bold: true,
        underline: false,
        color: {rgb: "000000"}
    },   
    fill: { fgColor: { rgb: "FFFFFF"}},    
    alignment: {
        horizontal: "center",
        textRotation: 60,
        wrapText: true
    }
};
var apisText = {
    font: {
        name: "Times New Roman",
        sz: 8,
        bold: true,        
        color: {rgb: "000000"}
    },    
    fill: { fgColor: { rgb: "FFFFFF"}},
    alignment: {
        horizontal: "center",
    }   
};
var numberLegText = {
    font: {
        name: "Calibri",
        sz: 11,
        bold: false,
        underline: false,
        color: {rgb: "000000"}
    }     
};
var emptyCell = {    
    fill: { fgColor: { rgb: "FFFFFF"}},
    alignment: {
        vertical: "center",
    }  
};
var legText = {
    font: {
        name: "Calibri",
        sz: 11,
        bold: false,
        underline: false,
        color: {rgb: "000000"}
    },    
    border: {
        top: {style: 'thin', color: {rgb: "000000"}},
        left: {style: 'thin', color: {rgb: "000000"}},
        right: {style: 'thin', color: {rgb: "000000"}},
        bottom: {style: 'thin', color: {rgb: "000000"}}
    }
};
var adittionalHeader = {
    font: {
        name: "Times New Roman",
        sz: 10,
        bold: true,        
        color: {rgb: "000000"}
    },
    fill: { fgColor: { rgb: "FFFFFF"}},
    alignment: {
        vertical: "center",
        horizontal: "right",
    }
};
var bottomQuoteBorder = {    
    fill: { fgColor: { rgb: "FFFFFF"}},
    border: {        
        bottom: {style: 'medium', color: {rgb: "000000"}}
    }
};
var rightQuoteBorder = {    
    fill: { fgColor: { rgb: "FFFFFF"}},
    border: {        
        right: {style: 'medium', color: {rgb: "000000"}}
    }
};
var rightBottomCornerQuoteBorder = {    
    fill: { fgColor: { rgb: "FFFFFF"}},
    border: {        
        right: {style: 'medium', color: {rgb: "000000"}},
        bottom: {style: 'medium', color: {rgb: "000000"}}
    }
};

var sheetName = "Quote Request";
var wscols=[];
wscols = [{wch: 5},{wch: 10},{wch: 10},{wch: 10},{wch: 10},{wch: 10},{wch: 10},{wch: 10},{wch: 10},{wch: 10},{wch: 10},{wch: 2}];
setColsWithToSheet(ws,wscols);
 
//assign the style to the complete rectangle for the request
fill_cell_custom(1,26,1,12, null, emptyCell);

fill_cell_custom(1,1,1,12, null, header);
fillCelluleByAddress(wb,ws, sheetName, "HANDLING QUOTE REQUEST - FLTPLAN", createObjetRowCol(1,1), header);

//Customer information
fillCelluleByAddress(wb,ws, sheetName, "Customer", createObjetRowCol(2,3), customerInformation);
fillCelluleByAddress(wb,ws, sheetName, "CST", createObjetRowCol(2,4), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, "Aircraft TAIL NUMBER", createObjetRowCol(3,1), customerInformation);
fillCelluleByAddress(wb,ws, sheetName, "C-FTNY", createObjetRowCol(3,4), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, "Aircraft TYPE (ICAO)", createObjetRowCol(4,1), customerInformation);
fillCelluleByAddress(wb,ws, sheetName, "FA10", createObjetRowCol(4,4), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, "USER:", createObjetRowCol(5,3), customerInformation);
fillCelluleByAddress(wb,ws, sheetName, "test", createObjetRowCol(5,4), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, "Password:", createObjetRowCol(6,1), customerInformation);
fillCelluleByAddress(wb,ws, sheetName, "test", createObjetRowCol(6,4), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, "Contact NAME", createObjetRowCol(7,1), customerInformation);
fillCelluleByAddress(wb,ws, sheetName, "Paul Gagnon", createObjetRowCol(7,4), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(7,5), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, "Contact E-MAIL", createObjetRowCol(8,1), customerInformation);
fillCelluleByAddress(wb,ws, sheetName, "paul.gagnon@pasi.ca", createObjetRowCol(8,4), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(8,5), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, "Contact Tel/Cel number", createObjetRowCol(9,1), customerInformation);
fillCelluleByAddress(wb,ws, sheetName, "[604-992-1023]", createObjetRowCol(9,4), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(9,5), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, "Alternate Tel/Cel number", createObjetRowCol(10,1), customerInformation);
fillCelluleByAddress(wb,ws, sheetName, "604-992-1024", createObjetRowCol(10,4), customerInformationText,'General');
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(10,5), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, "USA eAPIS:", createObjetRowCol(3,10), customerInformation);
fillCelluleByAddress(wb,ws, sheetName, "MX APIS:", createObjetRowCol(4,10), customerInformation);
fillCelluleByAddress(wb,ws, sheetName, "Y/N", createObjetRowCol(2,11), apisText);
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(3,11), customerInformationText);
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(4,11), customerInformationText);
//Trip header
fillCelluleByAddress(wb,ws, sheetName, "Date", createObjetRowCol(12,2), tripHeader);
fillCelluleByAddress(wb,ws, sheetName, "Dep Apt ICAO", createObjetRowCol(12,3), tripHeader);
fillCelluleByAddress(wb,ws, sheetName, "Arr Apt ICAO", createObjetRowCol(12,4), tripHeader);
fillCelluleByAddress(wb,ws, sheetName, "ETD UTC", createObjetRowCol(12,5), tripHeader);
fillCelluleByAddress(wb,ws, sheetName, "ETA UTC", createObjetRowCol(12,6), tripHeader);
fillCelluleByAddress(wb,ws, sheetName, "No. of Crew", createObjetRowCol(12,7), tripHeader);
fillCelluleByAddress(wb,ws, sheetName, "No. of PAX", createObjetRowCol(12,8), tripHeader);
fillCelluleByAddress(wb,ws, sheetName, "Ground Handling", createObjetRowCol(11,9), tripHeader60Degrees);
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(12,9), tripHeader60Degrees);
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(13,9), tripHeader60Degrees);
fillCelluleByAddress(wb,ws, sheetName, "Ground Transport", createObjetRowCol(11,10), tripHeader60Degrees);
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(12,10), tripHeader60Degrees);
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(13,10), tripHeader60Degrees);
fillCelluleByAddress(wb,ws, sheetName, "Lodging", createObjetRowCol(11,11), tripHeader60Degrees);
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(12,11), tripHeader60Degrees);
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(13,11), tripHeader60Degrees);
//Number leg column
fillCelluleByAddress(wb,ws, sheetName, "No.", createObjetRowCol(13,1), numberLegText);
fillCelluleByAddress(wb,ws, sheetName, "1", createObjetRowCol(14,1), numberLegText);
fillCelluleByAddress(wb,ws, sheetName, "2", createObjetRowCol(15,1), numberLegText);
fillCelluleByAddress(wb,ws, sheetName, "3", createObjetRowCol(16,1), numberLegText);
fillCelluleByAddress(wb,ws, sheetName, "4", createObjetRowCol(17,1), numberLegText);
fillCelluleByAddress(wb,ws, sheetName, "5", createObjetRowCol(18,1), numberLegText);
fillCelluleByAddress(wb,ws, sheetName, "6", createObjetRowCol(19,1), numberLegText);
fillCelluleByAddress(wb,ws, sheetName, "7", createObjetRowCol(20,1), numberLegText);
fillCelluleByAddress(wb,ws, sheetName, "8", createObjetRowCol(21,1), numberLegText);
fillCelluleByAddress(wb,ws, sheetName, "9", createObjetRowCol(22,1), numberLegText);
fillCelluleByAddress(wb,ws, sheetName, "10", createObjetRowCol(23,1), numberLegText);

//creates the borders legs
fill_cell_custom (14,23,2,11,null,legText)

//legs values
fillCelluleByAddress(wb,ws, sheetName, new Date("2018-05-28"), createObjetRowCol(14,2), legText);
fillCelluleByAddress(wb,ws, sheetName, "KLAX", createObjetRowCol(14,3), legText);
fillCelluleByAddress(wb,ws, sheetName, "MMAN", createObjetRowCol(14,4), legText);
fillCelluleByAddress(wb,ws, sheetName, "2", createObjetRowCol(14,7), legText);
fillCelluleByAddress(wb,ws, sheetName, "0", createObjetRowCol(14,8), legText);
fillCelluleByAddress(wb,ws, sheetName, new Date("2018-05-31"), createObjetRowCol(15,2), legText);
fillCelluleByAddress(wb,ws, sheetName, "MMAN", createObjetRowCol(15,3), legText);
fillCelluleByAddress(wb,ws, sheetName, "KLAX", createObjetRowCol(15,4), legText);
fillCelluleByAddress(wb,ws, sheetName, "2", createObjetRowCol(15,7), legText);
fillCelluleByAddress(wb,ws, sheetName, "0", createObjetRowCol(15,8), legText);

fillCelluleByAddress(wb,ws, sheetName, new Date("2018-05-31"), createObjetRowCol(15,2), legText);
//'date_format':'dd/mm/yyyy'

//Additional Services
fillCelluleByAddress(wb,ws, sheetName, "Additional Services (Please specify):", createObjetRowCol(25,1), adittionalHeader);
fillCelluleByAddress(wb,ws, sheetName, "Lorem ipsum dolor sit amet.", createObjetRowCol(25,4), customerInformationText);
fill_cell_custom(25,25,4,11,null,customerInformationText);

//quote border
fill_cell_custom(26,26,1,12,null,bottomQuoteBorder);
fill_cell_custom(2,25,12,12,null,rightQuoteBorder);
fillCelluleByAddress(wb,ws, sheetName, null, createObjetRowCol(26,12), rightBottomCornerQuoteBorder);


//Function that fill cells with a specified value 
//parameters (RowBegin,RowEnd,ColumnBegin, ColumnEnd, value to fill, css class style)
function fill_cell_custom(RowBegin,RowEnd,ColBegin, ColEnd, value, css) {     
    for (i=RowBegin;i<=RowEnd;i++){ 
        for (j=ColBegin;j<=ColEnd;j++) { 
            fillCelluleByAddress(wb,ws, sheetName, value, createObjetRowCol(i,j), css);
        } 
    }    
}
var wopts = setWopts();


